compile_mode :pop11 +strict;

uses lisp_subsystem
uses ml_subsystem
uses prolog_subsystem

;;;#_IF DEF POPC_COMPILING
;;;vars base_url url_decode mantohtml indextohtml vedtohtml;
;;;#_ENDIF
uses cgi_utils
uses cgi_to_vedhtml

#_IF DEF POPC_COMPILING
[
    ['$usepop/pop/x/ved/help/'  help]
    ['$usepop/pop/x/ved/ref/'   ref]
    ['$usepop/pop/x/ved/teach/' teach]
    ['$usepop/pop/x/pop/help/'  help]
    ['$usepop/pop/x/pop/ref/'   ref]
    ['$usepop/pop/x/pop/teach/' teach]
    ['$usepop/pop/x/pop/doc/'   doc]
    ['$poplocal/local/help/'    help]
    ['$usepop/pop/help/'        help]
    ['$poplocal/local/teach/'   teach]
    ['$usepop/pop/teach/'       teach]
    ['$usepop/pop/doc/'         doc]
    ['$usepop/pop/ref/'         ref]
    ['$usepop/pop/lib/proto/objectclass/help' help]
    ['$usepop/pop/lib/proto/objectclass/teach' teach]
    ['$usepop/pop/lib/proto/objectclass/ref' ref]
] -> vedhelplist;
[
    ['$usepop/pop/x/ved/ref/'   ref]
    ['$usepop/pop/x/ved/help/'  help]
    ['$usepop/pop/x/ved/teach/' teach]
    ['$usepop/pop/x/pop/ref/'   ref]
    ['$usepop/pop/x/pop/help/'  help]
    ['$usepop/pop/x/pop/teach/' teach]
    ['$usepop/pop/x/pop/doc/'   doc]
    ['$poplocal/local/ref/'     ref]
    ['$usepop/pop/ref/'         ref]
    ['$usepop/pop/doc/'         doc]
    ['$usepop/pop/help/'        help]
    ['$usepop/pop/teach/'       teach]
    ['$usepop/pop/lib/proto/objectclass/ref' ref]
    ['$usepop/pop/lib/proto/objectclass/help' help]
    ['$usepop/pop/lib/proto/objectclass/teach' teach]
] -> vedreflist;
[
    ['$usepop/pop/x/ved/teach/' teach]
    ['$usepop/pop/x/ved/help/'  help]
    ['$usepop/pop/x/ved/ref/'   ref]
    ['$usepop/pop/x/pop/teach/' teach]
    ['$usepop/pop/x/pop /help/' help]
    ['$usepop/pop/x/pop/ref/'   ref]
    ['$usepop/pop/x/pop/doc/'   doc]
    ['$poplocal/local/teach/'   teach]
    ['$usepop/pop/teach/'       teach]
    ['$poplocal/local/help/'    help]
    ['$usepop/pop/help/'        help]
    ['$usepop/pop/doc/'         doc]
    ['$usepop/pop/ref/'         ref]
    ['$usepop/pop/lib/proto/objectclass/teach' teach]
    ['$usepop/pop/lib/proto/objectclass/help' help]
    ['$usepop/pop/lib/proto/objectclass/ref' ref]
] -> vedteachlist;
[
    ['$usepop/pop/x/pop/doc/'   doc]
    ['$usepop/pop/x/pop/help/'  help]
    ['$usepop/pop/x/pop/ref/'   ref]
    ['$usepop/pop/x/pop/teach/' teach]
    ['$poplocal/local/doc/'     doc]
    ['$usepop/pop/doc/'         doc]
    ['$usepop/pop/ref/'         ref]
    ['$usepop/pop/help/'        help]
] -> veddoclist;
#_ENDIF

define cgi_get_to_vedhtml();
    lvars type="help", name=nullstring, system="pop11", keyword=false, key, value,
    query = systranslate('QUERY_STRING');
/*
dlocal prmishap = procedure(message,list);
        sysprmessage(destlist(list),message,'CGI Error -',0);
    endprocedure;
    */
dlocal base_url;
    if (systranslate('$usepop_base_url') ->> key) then
        key -> base_url;
    endif;

    npr('Content-type: text/html');
    nl(1);

    url_decode(query) -> query;
    if query.isstring then
        npr('<HTML><P> Error decoding query');
        npr(query);
        npr('</HTML>');
        return();
    endif;

    until query == [] do
        dest(query) -> query -> key;
        if query == [] then
            npr('<HTML><P> Error decoding query missing value for key');
            npr(key);
            npr('</HTML>');
            return();
        endif;
        dest(query) -> query -> value;
        switchon consword(uppertolower(key)) ==
        case "system" then consword(value) -> system;
        case "type"   then value -> type;
        case "name"   then value -> name;
        case "keyword"   then uppertolower(value) = 'true' -> keyword;
        else
            npr('<HTML><P> Error decoding query unknown key value pair');
            npr(key);npr(value);
            npr('</HTML>');
            return();
        endswitchon;
    enduntil;

    switchon system =
    case "pop11"  then
        if type = 'man' or type = 'unix' then
            "man" -> system;
            nullstring -> type;
        elseif name = nullstring then 'pop11' -> name;
        endif;
    case "lisp"   then
        if name = nullstring then 'clisp' -> name; endif;
    case "ml"     then
        if name = nullstring then 'pml' -> name; endif;
    case "prolog" then
        if name = nullstring then 'prolog' -> name; endif;
    endswitchon;

    if system = "man" or system = "unix" then
/*
        if hasstartstring(systranslate('REMOTE_ADDR'),'192.133.244')
        or hasstartstring(systranslate('REMOTE_ADDR'),'134.225')
        then
            mantohtml(type,name,keyword);
        else
            npr('Sorry no access to manual pages outside The University of Reading');
        endif
*/
        mantohtml(type,name,keyword);
    elseif issubstring('ndex',name) then
        indextohtml(system,type,name);
    else
        vedtohtml(system,type,name);
    endif;
enddefine;
